Robotsystem from Robot Group Leipzig: ShortCircuit Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# ShortCircuit Class Reference

`#include <shortcircuit.h>`

Inheritance diagram for ShortCircuit:

[legend]
Collaboration diagram for ShortCircuit:

[legend]
List of all members.

## Detailed Description

Definition at line 64 of file shortcircuit.h.

## Public Member Functions
| ShortCircuit (const OdeHandle &odeHandle, const OsgHandle &osgHandle, int sensornumber, int motornumber)
virtual void | update ()
| update the OSG notes here
virtual void | place (const osg::Matrix &pose)
| sets the pose of the vehicle
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual void | doInternalStuff (const GlobalData &globalData)
| this function is called in each timestep.
virtual bool | collisionCallback (void *data, dGeomID o1, dGeomID o2)
| checks for internal collisions and treats them.
## Protected Member Functions
virtual Primitive * | getMainPrimitive () const
| the main object of the robot, which is used for position and speed tracking
## Protected Attributes
int | sensorno
int | motorno
motor * | motors

## Constructor & Destructor Documentation

ShortCircuit | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | int | sensornumber,
|  | int | motornumber
| ) |

| Definition at line 44 of file shortcircuit.cpp.

## Member Function Documentation

virtual bool collisionCallback | ( | void * | data,
|  | dGeomID | o1,
|  | dGeomID | o2
| ) | `[inline, virtual]`

| checks for internal collisions and treats them. In case of a treatment return true (collision will be ignored by other objects and the default routine) else false (collision is passed to other objects and (if not treated) to the default routine). Implements OdeRobot. Definition at line 102 of file shortcircuit.h.

virtual void doInternalStuff | ( | const GlobalData & | globalData | ) | `[inline, virtual]`

  | this function is called in each timestep. It should perform robot-internal checks, like space-internal collision detection, sensor resets/update etc. Parameters:
  | globalData | structure that contains global data from the simulation environment
Implements OdeRobot. Definition at line 100 of file shortcircuit.h.

virtual Primitive* getMainPrimitive | ( |  | ) | const`[inline, protected, virtual]`

| the main object of the robot, which is used for position and speed tracking Implements OdeRobot. Definition at line 106 of file shortcircuit.h.

virtual int getMotorNumber | ( |  | ) | `[inline, virtual]`

| returns number of motors Implements AbstractRobot. Definition at line 94 of file shortcircuit.h.

virtual int getSensorNumber | ( |  | ) | `[inline, virtual]`

| returns number of sensors Implements AbstractRobot. Definition at line 90 of file shortcircuit.h.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber
| ) | `[virtual]`

  | returns actual sensorvalues Parameters:
  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array
Returns: number of actually written sensors Implements AbstractRobot. Definition at line 71 of file shortcircuit.cpp.

virtual void place | ( | const osg::Matrix & | pose | ) | `[inline, virtual]`

  | sets the pose of the vehicle Parameters:
  | pose | desired 4x4 pose matrix
Implements OdeRobot. Definition at line 73 of file shortcircuit.h.

void setMotors | ( | const motor * | motors,
|  | int | motornumber
| ) | `[virtual]`

  | sets actual motorcommands Parameters:
  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array
Implements AbstractRobot. Definition at line 61 of file shortcircuit.cpp.

virtual void update | ( |  | ) | `[inline, virtual]`

| update the OSG notes here Implements OdeRobot. Definition at line 68 of file shortcircuit.h.

## Member Data Documentation

int motorno`[protected]`

| Definition at line 110 of file shortcircuit.h.

motor* motors`[protected]`

| Definition at line 111 of file shortcircuit.h.

int sensorno`[protected]`

| Definition at line 109 of file shortcircuit.h.